//code by Zhenyu Yang

Tree tree;
Branch cursorBranch;
color bakcGroundColor = color(224, 224, 204);

float goldenRatio = 0.61803398875f;

float camX = 0;
float camY = 0;

int textSizeint = 15;

float camTargetX = 0;
float camTargetY = 0;

float millisTime = 0;

boolean ifStartGrow = true;

float price_prev = 0;
float price_current = 0;

float gMin = height;

boolean ifMovecam = false;

boolean ifUpdate = true;

boolean ifBlackOldBranches = true;

boolean ifShowTimeLines = true;

boolean isDragging = false;
float mouseDrageStartX = 0;
float mouseDrageStartY = 0;

int dragEndFrame = -1;

ArrayList<FxData> fxDatas = new ArrayList<FxData>();
//ReinforcementLearning reinforcementLearningObject;  ReinforcementLearning is a protected class, only permited to use by UCSB ECE Learning-Based Multimedia Lab
void setup() 
{

  //size(1334, 750);
  //size(600, 800);
  fullScreen();



  //reinforcementLearningObject = new ReinforcementLearning();
  //tree  = new Tree(width*0.618, height-20, 9, 0, reinforcementLearningObject.getProb());  //ReinforcementLearning is a protected class, only permited to use by UCSB ECE Learning-Based Multimedia Lab


  tree  = new Tree(width*0.618, height-20, 9, 0, getProb());
  tree.buildTree();
  cursorBranch = tree.mainBranch;
  cursorBranch.isCursor = true;

  fill(baseColor);
  millisTime = millis();
  textSize(textSizeint);
}

void draw() { 
  background(bakcGroundColor);


  //gui
  textSize(height/30.0);
  text("Forex tree", 100, height/10);
  textSize(height/60.0);
  text("/*ZHENYU  YANG*/\nA 2D data visualization based \non the real-time EUR/USD \nforex rate and a pre-trained \nreinforment learning model.", 100, height/9+height/30.0);

  float errX = camTargetX - camX;
  float errY = camTargetY - camY;

  if (ifMovecam) {

    if (abs(errY)>20||abs(errX)>20) {

      camX = camX + (errX)*0.01;
      camY = camY + (errY)*0.01;
    } else {
      ifMovecam = false;
      println("ifMovecam = false");
    }
  }

  translate(camX, camY);
  tree.drawTreeAnim(123);


  //update agingRate
  tree.agingRate = 1+((tree.mainBranchLength - cursorBranch.branchLength)*0.0001);


  if (ifUpdate&&frameCount%800==0) {
    //millisTime = millis();
    FxData temp = fetchData();
    //println("(price_current - price_prev) = "+(price_current - price_prev>0));
    if ((price_current - price_prev)>0) {
      moveCursorLeft(temp);
    } else {
      moveCursorRight(temp);
    }
  }

  if (fxDatas.size()>0) {
    fxDatas.get(fxDatas.size()-1).timeLineY = cursorBranch.location.y;
  }

  //draw timeLine
  if (ifShowTimeLines)
    for (int i = 0; i<fxDatas.size(); i++) {
      //println("fxDatas.get("+i+").timeLineY = "+fxDatas.get(i).timeLineY);
      stroke(baseColor);
      fill(baseColor);
      line(-camX, fxDatas.get(i).timeLineY, width-camX, fxDatas.get(i).timeLineY);
      text("EUR/USD"+fxDatas.get(i).price+"@"+fxDatas.get(i).fetchTime+"\nraise probability:"+fxDatas.get(i).raiseProb, -camX, fxDatas.get(i).timeLineY-5);
    }


  if (isDragging) {
    camX = mouseX-mouseDrageStartX;
    camY = mouseY-mouseDrageStartY;

    if (camY<=0) {
      camY=0;
    }
  }
} 

void  mousePressed() {
  if (!isDragging) {
    mouseDrageStartX = mouseX-camX;
    mouseDrageStartY = mouseY-camY;

    isDragging = true;
    ifMovecam = false;
  }
}

void  mouseReleased() {
  isDragging = false;
  dragEndFrame = frameCount;
}



void keyPressed() {
  if (key=='t') {
    ifShowTimeLines = !ifShowTimeLines;
  }
}

public void moveCursorLeft(FxData temp) {
  if (cursorBranch.children.size()!=0) {
    cursorBranch.isCursor = false;
    cursorBranch.blackOut();

    Tree t  = new Tree(0, 0, 8, random(-0.6, 0.6), temp.raiseProb);
    t.buildTree();
    cursorBranch = cursorBranch.children.get(0);
    cursorBranch.addBranches(t.mainBranch);
    cursorBranch = t.mainBranch;
    cursorBranch.isCursor = true;
  }
}

public void moveCursorRight(FxData temp) {
  if (cursorBranch.children.size()!=0) {
    cursorBranch.isCursor = false;
    cursorBranch.blackOut();

    Tree t  = new Tree(0, 0, 8, random(-0.6, 0.6), temp.raiseProb);
    t.buildTree();

    cursorBranch = cursorBranch.children.get(cursorBranch.children.size()-1);
    cursorBranch.addBranches(t.mainBranch);
    cursorBranch = t.mainBranch;
    cursorBranch.isCursor = true;
  }
}